﻿using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using Syncfusion.SfGauge.XForms;
using Xamarin.Forms;

namespace CircularGauge
{
	public partial class CircularGaugePage : ContentPage
	{
		ObservableCollection<Scale> scales = new ObservableCollection<Scale>();
		SfCircularGauge circulargauge = new SfCircularGauge();

    
		public CircularGaugePage()
		{
			InitializeComponent();

			Header header = new Header();

			header.Text = "Speedmeter";
			header.TextSize = 20;
			header.Position = Device.OnPlatform(iOS: new Point(.3, .7), Android: new Point(0.5, 0.7), WinPhone: new Point(0.38, 0.7));			
			header.ForegroundColor = Color.Gray;
			circulargauge.Headers.Add(header);
		


			Scale scale = new Scale();
			scale.StartValue = 0;
			scale.EndValue = 100;
			scale.Interval = 10;
			scale.StartAngle = 135;
			scale.SweepAngle = 270;
			scale.RimThickness = 10;
			scale.RimColor = Color.FromHex("#2bbfb8");

			scale.MinorTicksPerInterval = 2;
			scale.LabelFontSize = 15;
			scale.LabelColor = Color.FromRgb(204, 50, 50);

			scale.LabelOffset = 0.2;

			Range range1 = new Range();
			range1.StartValue = 80;
			range1.EndValue = 100;
			range1.Color = Color.FromHex("#d14646");
			range1.Thickness = 10;

			scale.Ranges.Add(range1);

			NeedlePointer needlePointer = new NeedlePointer();
			needlePointer.Value = 60;
			needlePointer.Color = Color.Gray;
			needlePointer.KnobColor = Color.FromHex("#2bbfb8");
			needlePointer.Thickness = 5;
			needlePointer.KnobRadius = 20;
			needlePointer.LengthFactor = 0.8;

			scale.Pointers.Add(needlePointer);

			TickSettings minor = new TickSettings();
			minor.Length = 6;
			minor.Color = Color.FromRgb(0, 72, 255);
			minor.Thickness = 3;
			minor.Offset = 0.5;

			scale.MinorTickSettings = minor;



			TickSettings major = new TickSettings();
			major.Length = 12;
			major.Color = Color.FromRgb(0, 0, 0);
			major.Thickness = 3;
			major.Offset = Device.OnPlatform(0.05, 0.05, 0.1);
		
			scale.MajorTickSettings = major;

			scales.Add(scale);
		
			circulargauge.Scales = scales;

			this.Content = circulargauge;
		}
	}
}

